\chapter{Permanent Magnet Synchronous Motors \label{chap:MotorModel}}


% Chapter intro
This chapter describes the principle of the operation of a \gls{pmsm} and the mathematical model.
The model is then transformed into a two-phase equivalent model using the Clarke transformation.
Further, the DQ model is obtained using the Park transformation, which is then linearized and discretized.
Then, model parameters are discussed.
Finally, constraints on the inputs and state variables are addressed.
For a rigorous derivation of the model, the reader is referred to \cite{ChiassonBook} and \cite{KrauseBook}.
Also, the model of a \gls{bldc} motor can be found in \cite{ChiassonBook}.




\section{Principle of Operation}


% Principle of operation
Fig. \ref{fig:PMSM_Principle_a} shows the basic idea of the operation of a \gls{pmsm}.
The motor consists of three stator phases, usually denoted as A, B, and C, and a permanent magnet on the rotor.
Each of the three phases consists of two coils that generate a magnetic field when current is running through them.
The orientation of the magnetic field around each coil is determined by the direction of the current.
The figure depicts the orientation for a given situation by N (for North pole) and S (for South pole).
The stator magnetic poles attract opposite rotor poles and create torque.
The stator currents are varied such that the created torque turns the rotor in the desired direction. 
At constant rotor speed and constant external load torque, the optimal phase currents are of sinusoidal shape, as a function of time, as shown in fig. \ref{fig:PMSM_Principle_b}.
Such current waveforms produce constant torque that compensates for the load torque and friction.
The optimal shape is a result of the sinusoidal shape of back \glspl{emf}, which is a result of the actual motor construction and geometry.


% Different PMSM configurations
Although a typical \gls{pmsm} consists of three phases, the number may be different.
The same applies to the number of coils per phase and the number of rotor magnets.
The phase windings  are not necessarily solenoidal, as in fig. \ref{fig:PMSM_Principle_a}.
Instead, they can be distributed around the stator perimeter.
Also, the rotor magnets may be either inside the stator, as in fig. \ref{fig:PMSM_Principle_a}, or outside.
Such configurations are called \gls{ipmsm} and \gls{spmsm}, respectively.
Usually, the three phases are not controlled independently but, rather, they are connected together in a star or delta configuration, which are depicted in fig. \ref{fig:PMSM_Configurations}.
Both configurations reduce the number of wires connected to the motor and make it a three-terminal device.

\begin{figure}[tb]
	%\begin{center}
		\begin{subfigure}[b]{0.60\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/pmsm_principle_a/pmsm_principle_a.pdf}
  			\subcaption{Principle of operation of \gls{pmsm}. \label{fig:PMSM_Principle_a}}
		\end{subfigure}
		\hfill
		\begin{subfigure}[b]{0.325\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/pmsm_principle_b/pmsm_principle_b.pdf}
  			\subcaption{Optimal current waveforms. \label{fig:PMSM_Principle_b}}
		\end{subfigure}
  		\caption{Principle of operation of \gls{pmsm} \subref*{fig:PMSM_Principle_a} and optimal current waveforms at constant speed and constant load torque \subref*{fig:PMSM_Principle_b}. The three phases A, B, and C are represented by red, blue, and yellow colors, respectively.\label{fig:PMSM_Principle}}
	%\end{center}
\end{figure}


\begin{figure}[tb]
	\begin{center}
		\begin{subfigure}[b]{0.25\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/pmsm_configurations/pmsm_star.pdf}
  			\subcaption{Star configuration. \label{fig:PMSM_star}}
		\end{subfigure}
		\hspace{0.1\textwidth}
		\begin{subfigure}[b]{0.25\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/pmsm_configurations/pmsm_delta.pdf}
  			\subcaption{Delta configuration. \label{fig:PMSM_delta}}
		\end{subfigure}
  		\caption{Two common configurations of \gls{pmsm} phase windings.\label{fig:PMSM_Configurations}}
	\end{center}
\end{figure}




\section{Mathematical model}


\subsection{Assumptions}
% State basic assumptions
The following mathematical model was derived making certain assumptions.
Firstly, the motor is assumed to be a three-phase symmetrical \gls{pmsm}.
In other words, all three phases have the same properties and the only difference is that they are rotated in space by 120 degrees with respect to each other, and the motor geometry is such that the back \glspl{emf} are of sinusoidal shape.
Secondly, it is assumed that the motor is made of ideal linear magnetic materials and that there are no losses in the magnetic circuit. 
Hence, effects such as magnetic saturation of the materials, hysteresis of B-H curve, and eddy-current losses  are not considered.
Also, the model parameters are assumed to be constant, whereas in reality they can vary significantly due to temperature rise in the motor and due to magnetic saturation.


\subsection{Definition of Rotor Angle}

% Define angle and angular velocity
As depicted in fig. \ref{fig:PMSM_Principle_a}, the rotor angle $\theta$ is defined to be the angle between the magnetic axes of the rotor magnet and phase A.
This implies that positive current through phase A creates torque that attracts the rotor to zero angle.
The orientation is such that phase B is rotated in space by $120$ degrees from phase A and phase C is rotated by $240$ degrees (or $-120$ degrees) from phase A. 
The angular velocity is
\begin{alignat}{1}
	\omega \meq \derivative{\theta}{t}.
\end{alignat}


% Define electrical angle and electrical angular velocity
When there are more coils per phase and/or more rotor magnets, there are more possibilities to choose zero angle according to the above definition as the rotor and/or phase A have more than one magnetic axis.
In such case, any position at which the magnetic axes are aligned is picked as zero angle.
The effects of the rotor position on the phase windings are periodic functions of $\theta$ with period $2\pi/n_{\textrm{pp}}$, where $n_{\textrm{pp}}$ is the number of pole pairs on the stator and the rotor.


\subsection{Voltage Equations \label{sec:ch2VotlageEqsUniform}}


\begin{figure}[tb]
	\begin{center}
		\begin{subfigure}[b]{0.44\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/pmsm_model_star/pmsm_model_star.pdf}
  			\subcaption{Star configuration. \label{fig:PMSM_Model_Star}}
		\end{subfigure}
		\hspace{0.1\textwidth}
		\begin{subfigure}[b]{0.44\textwidth}
			%\centering
 	 		\includegraphics[width=0.95\textwidth]{figs/pmsm_model_delta/pmsm_model_delta.pdf}
 	 		\subcaption{Delta configuration. \label{fig:PMSM_Model_Delta}}
		\end{subfigure}
	  	\caption{Model of electrical part of \gls{pmsm} (the voltage arrows are oriented toward the reference point).\label{fig:PMSM_Model}}
	\end{center}
\end{figure}


% Describe model - voltage equations
Fig. \ref{fig:PMSM_Model} shows model of electrical part of \gls{pmsm} in star and delta configurations.
In both cases, the phase voltages $v_{\textrm{a}}$, $v_{\textrm{b}}$, and $v_{\textrm{c}}$ are expressed in terms of the phase currents $i_{\textrm{a}}$, $i_{\textrm{b}}$, $i_{\textrm{c}}$ and the total flux linkage in each phase $\psi_{\textrm{a}}$, $\psi_{\textrm{b}}$, $\psi_{\textrm{c}}$ as
\begin{alignat}{1}
	\bm{v}_{\textrm{abc}} \meq R_{\textrm{s}}\bm{i}_{\textrm{abc}} + \derivative{}{t}\bm{\psi}_{\textrm{abc}},\label{eq:ModelVoltageEq1}
\end{alignat}
where
\begin{alignat}{1}
	\bm{v}_{\textrm{abc}}  =
	\begin{bmatrix}
		v_{\textrm{a}} \cr v_{\textrm{b}} \cr v_{\textrm{c}}
	\end{bmatrix}, \quad
	\bm{i}_{\textrm{abc}} =
	\begin{bmatrix}
		i_{\textrm{a}} \cr i_{\textrm{b}} \cr i_{\textrm{c}}
	\end{bmatrix}, \quad
	\bm{\psi}_{\textrm{abc}} =
	\begin{bmatrix}
		\psi_{\textrm{a}} \cr \psi_{\textrm{b}} \cr \psi_{\textrm{c}}
	\end{bmatrix},
\end{alignat}
and $R_{\textrm{s}}$ is phase resistance.
The flux linkages consist of two components
\begin{alignat}{1}
	\bm{\psi}_{\textrm{abc}} \meq \bm{\psi}_{\textrm{abcs}} + \bm{\psi}_{\textrm{abcr}}, \label{eq:ModelPsiRS}
\end{alignat}
where 
$\bm{\psi}_{\textrm{abcs}} =
\begin{bsmallmatrix}
	\psi_{\textrm{as}} & \psi_{\textrm{bs}} & \psi_{\textrm{cs}}
\end{bsmallmatrix}\transpose$
are the components of the flux linkages due to the stator currents and
$\bm{\psi}_{\textrm{abcr}} =
\begin{bsmallmatrix}
	\psi_{\textrm{ar}} & \psi_{\textrm{br}} & \psi_{\textrm{cr}}
\end{bsmallmatrix}\transpose$
are the components of the flux linkages due to the rotor magnets.
The components of the flux linkages due to the stator currents are
\begin{alignat}{1}
	\bm{\psi}_{\textrm{abcs}} \meq \bm{L}\bm{i}_{\textrm{abc}} \label{eq:ModelPsiSEq1}
\end{alignat}
with $\bm{L}$ being the inductance matrix.
If the air gap between the stator and rotor is uniform, self-inductance of each phase $L_{\textrm{s}}$ and mutual inductance between each two phases $-M_{\textrm{s}}$ are constant and the inductance matrix is
\begin{alignat}{1}
	\bm{L}_{\textrm{uniform}} \meq \begin{bmatrix}
		 L_{\textrm{s}} & -M_{\textrm{s}} & -M_{\textrm{s}} \cr
	   	-M_{\textrm{s}} &  L_{\textrm{s}} & -M_{\textrm{s}} \cr
	    -M_{\textrm{s}} & -M_{\textrm{s}} &  L_{\textrm{s}}
	\end{bmatrix}. \label{eq:Model_InductanceMatUniform}
\end{alignat}
The negative signs at the mutual inductances are due to the phases being rotated with respect to each other by 120 degrees and, thus, positive current in a phase winding induces negative currents in the other two phases.
If the motor has salient poles and the air gap is non-uniform, the inductances vary with the rotor angle.
The changes in the inductances can be approximated as
\begin{alignat}{1}
	\bm{L} \meq \bm{L}_{\textrm{uniform}} + L_{\textrm{g}}\begin{bmatrix}
		\cos2\braRound{n_{\textrm{pp}}\theta} &
		\cos2\braRound{n_{\textrm{pp}}\theta - \frac{\pi}{3}} &
		\cos2\braRound{n_{\textrm{pp}}\theta + \frac{\pi}{3}} \cr
		\cos2\braRound{n_{\textrm{pp}}\theta - \frac{\pi}{3}} &
		\cos2\braRound{n_{\textrm{pp}}\theta - \frac{2\pi}{3}} &
		\cos2\braRound{n_{\textrm{pp}}\theta} \cr
		\cos2\braRound{n_{\textrm{pp}}\theta + \frac{\pi}{3}} &
		\cos2\braRound{n_{\textrm{pp}}\theta} &
		\cos2\braRound{n_{\textrm{pp}}\theta + \frac{2\pi}{3}}
	\end{bmatrix}, \label{eq:Model_InductanceMatSalient}
\end{alignat}
where the constant inductance matrix $\bm{L}_{\textrm{uniform}}$ is used to represent the mean inductances and $L_{\textrm{g}}$ is the amplitude of the changes in inductance.
The fluctuations are periodic functions with period $\pi/n_{\textrm{pp}}$, which corresponds to the fact that the inductances are not affected by the rotor magnetic field and, hence, the polarity of the rotor magnets does not matter.
It is assumed that flux linkages due to rotor magnets are
\begin{alignat}{1}
	\bm{\psi}_{\textrm{abcr}} \meq \mathit{\Psi}_{\textrm{m}}
	\begin{bmatrix}
		\cos\braRound{n_{\textrm{pp}}\theta} \cr
		\cos\braRound{n_{\textrm{pp}}\theta - \frac{2\pi}{3}} \cr
		\cos\braRound{n_{\textrm{pp}}\theta + \frac{2\pi}{3}}
	\end{bmatrix}, \label{eq:Model_FluxLinkagesDueTorRotor}
\end{alignat}
where $\mathit{\Psi}_{\textrm{m}}$ denotes the amplitude of the components of $\bm{\psi}_{\textrm{abcr}}$.
The back \glspl{emf} in each phase are then%
\footnote{
Some texts use different sign convention and define the back \glspl{emf} to be the negative of the expression in~\eqref{eq:ModelBackEMFs1}.
The sign conventions used here is, however, more common \cite{ChiassonBook}.
}
\begin{alignat}{2}
	\bm{e}_{\textrm{abc}} \meq 
	\begin{bmatrix}
		e_{\textrm{a}} \cr e_{\textrm{b}} \cr e_{\textrm{c}}
	\end{bmatrix} \meq
 	\derivative{}{t}\bm{\psi}_{\textrm{abcr}} \meq
	 -n_{\textrm{pp}}\omega\mathit{\Psi}_{\textrm{m}}
	\begin{bmatrix}
		\sin\braRound{n_{\textrm{pp}}\theta} \cr
		\sin\braRound{n_{\textrm{pp}}\theta - \frac{2\pi}{3}} \cr
		\sin\braRound{n_{\textrm{pp}}\theta + \frac{2\pi}{3}}
	\end{bmatrix}. \label{eq:ModelBackEMFs1}
\end{alignat}
Using \eqref{eq:ModelPsiRS}, \eqref{eq:ModelPsiSEq1} and \eqref{eq:ModelBackEMFs1}, the phase voltages $\bm{v}_{\textrm{abc}}$  are expressed as
\begin{alignat}{1}
	\bm{v}_{\textrm{abc}} \meq  R_{\textrm{s}}\bm{i}_{\textrm{abc}} + \bm{L}\derivative{\bm{i}_{\textrm{abc}}}{t} + \omega\pderivative{\bm{L}}{\theta}\bm{i}_{\textrm{abc}} + \bm{e}_{\textrm{abc}}. \label{eq:ModelVoltageEq2}
\end{alignat}
where the effects of the magnetic field of the rotor magnets are contained in the back \gls{emf} term.


\subsection{Balanced Conditions}

% Balanced conditions of star-connected PMSM
In a star-connected \gls{pmsm}, Kirchhoff's current law applied at the motor neutral point $\hat{\textrm{N}}$  states that the phase currents are balanced and satisfy
\begin{alignat}{1}
	i_{\textrm{a}} + i_{\textrm{b}} + i_{\textrm{c}} \meq 0. \label{eq:BalancedConditionsCurrents1}
\end{alignat}
From \eqref{eq:ModelPsiSEq1} and \eqref{eq:Model_InductanceMatSalient} it follows that
\begin{alignat}{1}
	\psi_{\textrm{as}} + \psi_{\textrm{bs}} + \psi_{\textrm{cs}} \meq 0.
\end{alignat}
The sinusoidal shape of flux linkages due to rotor magnets given by \eqref{eq:Model_FluxLinkagesDueTorRotor} implies
\begin{alignat}{1}
	\psi_{\textrm{ar}} + \psi_{\textrm{br}} + \psi_{\textrm{cr}} \meq 0
\end{alignat}
and as a result
\begin{alignat}{1}
	v_{\textrm{a}} + v_{\textrm{b}} + v_{\textrm{c}} \meq 0.
\end{alignat}
Put into words, the phase voltages are also balanced.

% Balanced conditions of delta-connected PMSM
In a delta-connected \gls{pmsm}, Kirchhoff's voltage law applied to the phase voltages states that they are balanced and satisfy
\begin{alignat}{1}
	v_{\textrm{a}} + v_{\textrm{b}} + v_{\textrm{c}} \meq 0.
\end{alignat}
The sinusoidal shape of back \glspl{emf} given by \eqref{eq:ModelBackEMFs1} implies
\begin{alignat}{1}
	e_{\textrm{a}} + e_{\textrm{b}} + e_{\textrm{c}} \meq 0.
\end{alignat}
Therefore, summing up the equations in \eqref{eq:ModelVoltageEq2} gives
\begin{alignat}{1}
	0 \meq R_{\textrm{s}}i_{\textrm{zs}} + (L_{\textrm{s}} - 2M_{\textrm{s}})\derivative{}{t}i_{\textrm{zs}}, \label{eq:PMSM_Model_ZS_Current}
\end{alignat}
where
\begin{alignat}{1}
	i_{\textrm{zs}} \meq \frac{1}{3}(i_{\textrm{a}} + i_{\textrm{b}} + i_{\textrm{c}})
\end{alignat}
is the zero-sequence (also called common-mode) current.
This is the common component of the phase currents which is running in circle in the delta-connected \gls{pmsm}.
Under ideal conditions, there are no voltages in \eqref{eq:PMSM_Model_ZS_Current} that would drive the zero-sequence current and for this reason
\begin{alignat}{1}
	i_{\textrm{zs}} \meq 0.
\end{alignat}
Thus, the phase currents are balanced and
\begin{alignat}{1}
	i_{\textrm{a}} + i_{\textrm{b}} + i_{\textrm{c}} \meq 0. \label{eq:BalancedConditionsCurrents2}
\end{alignat}
In practice, the zero-sequence current might be nonzero due to imbalance and asymmetry in the motor.
For example, if the back \glspl{emf} are non-sinusoidal and contain triplen harmonics (as in case of \gls{bldc} motors), they are not balanced and the common-mode back \gls{emf} drives the zero-sequence current.
However, in delta-connected \glspl{pmsm} $i_{\textrm{zs}}$ is usually negligible.


\subsection{Relationship Between Phase and Source Variables \label{subsec:PhaseAndSourceVariables}}


% Figure
\begin{figure}[tb]
	\begin{center}
		\includegraphics[width=0.35\textwidth]{figs/pmsm_model_3p_source/pmsm_model_3p_source.pdf}
		\caption{\Gls{pmsm} connected to a three-phase voltage source. \label{fig:PMSM_3P_Source}}
	\end{center}
\end{figure}


% Define source variables
The voltage equations given in section \ref{sec:ch2VotlageEqsUniform} are in terms of the phase voltages $\bm{v}_{\textrm{abc}}$ and phase currents $\bm{i}_{\textrm{abc}}$.
The manipulated variables are, however, the source voltages
\begin{alignat}{1}
	\bm{v}_{\textrm{abcs}} \meq \begin{bmatrix}
		v_{\textrm{as}} & v_{\textrm{bs}} & v_{\textrm{cs}}
	\end{bmatrix}\transpose
\end{alignat}
and the currents drawn from the three-phase power supply are the source currents
\begin{alignat}{1}
	\bm{i}_{\textrm{abcs}} \meq \begin{bmatrix}
		i_{\textrm{as}} & i_{\textrm{bs}} & i_{\textrm{cs}}
	\end{bmatrix}\transpose.
\end{alignat}
This is shown in fig. \ref{fig:PMSM_3P_Source}.
The relationship between the phase variables and the source variables is now given.


% Relationship between phase and source variables - star connected PMSM
In star-connected \gls{pmsm}, the phase voltages $\bm{v}_{\textrm{abc}}$ are taken with respect to the motor neutral point $\hat{\textrm{N}}$.
The source voltages $v_{\textrm{as}}$, $v_{\textrm{bs}}$, $v_{\textrm{cs}}$ are taken with respect to the source neutral point $\textrm{N}$.
The relationship between the two sets of voltages is
\begin{alignat}{1}
	v_{\textrm{as}} \meq v_{\textrm{a}} + v_{\hat{\textrm{n}}\textrm{n}},\\
	v_{\textrm{bs}} \meq v_{\textrm{b}} + v_{\hat{\textrm{n}}\textrm{n}},\\
	v_{\textrm{cs}} \meq v_{\textrm{c}} + v_{\hat{\textrm{n}}\textrm{n}}
\end{alignat}
where $v_{\hat{\textrm{n}}\textrm{n}}$ is the voltage at the motor neutral point $\hat{\textrm{N}}$ with respect to the source neutral point $\textrm{N}$.
Summing up these three equations and using the balanced conditions of  $v_{\textrm{a}}$, $v_{\textrm{b}}$, and $v_{\textrm{c}}$ gives
\begin{alignat}{1}
	 v_{\hat{\textrm{n}}\textrm{n}} \meq \frac{1}{3}\braRound{v_{\textrm{as}} + v_{\textrm{bs}} + v_{\textrm{cs}}}.
\end{alignat}
Thus, the voltage between the two neutral points $v_{\hat{\textrm{n}}\textrm{n}}$ is equal to the common-mode voltage of the three source voltages.
The source voltages need not to be balanced and, therefore, the common-mode voltage $v_{\hat{\textrm{n}}\textrm{n}}$ may be chosen non-zero.
However, $v_{\hat{\textrm{n}}\textrm{n}}$ does not drive the phase currents because the phase voltages $v_{\textrm{a}}$, $v_{\textrm{b}}$, and $v_{\textrm{c}}$ are obtained from the source voltages by substracting $v_{\hat{\textrm{n}}\textrm{n}}$.
In other words, only the differential modes of the source voltages drive the phase currents and the common-mode voltage can be chosen arbitrarily.
For example, when the limits on the maximum and minimum source voltage are considered, the common-mode can be used to shift the source voltages such that the voltage range is fully utilized.
The phase currents in star-connected \gls{pmsm} are equal to the source currents
\begin{alignat}{1}
	\bm{i}_{\textrm{abcs}} \meq \bm{i}_{\textrm{abc}}.
\end{alignat}


% Relationship between phase and source variables - delta connected PMSM
In delta-connected \gls{pmsm}, the phase voltages $\bm{v}_{\textrm{abc}}$ are the line-to-line voltages
\begin{alignat}{1}
	v_{\textrm{a}} \meq v_{\textrm{as}} - v_{\textrm{bs}}, \\
	v_{\textrm{b}} \meq v_{\textrm{bs}} - v_{\textrm{cs}}, \\
	v_{\textrm{c}} \meq v_{\textrm{cs}} - v_{\textrm{as}}. 
\end{alignat}
The inverse relationship is
\begin{alignat}{1}
	v_{\textrm{as}} \meq \frac{1}{3}(v_{\textrm{a}} - v_{\textrm{c}}) + v_{\textrm{cms}}, \\
	v_{\textrm{bs}} \meq \frac{1}{3}(v_{\textrm{b}} - v_{\textrm{a}}) + v_{\textrm{cms}}, \\
	v_{\textrm{cs}} \meq \frac{1}{3}(v_{\textrm{c}} - v_{\textrm{b}}) + v_{\textrm{cms}},
\end{alignat}
where
\begin{alignat}{1}
	v_{\textrm{cms}} \meq \frac{1}{3}(v_{\textrm{as}} + v_{\textrm{bs}} + v_{\textrm{cs}})
\end{alignat}
is the common-mode voltage of the source voltages.
As the phase voltages are line-to-line, they do not depend on the common mode of the source voltages and $v_{\textrm{cms}}$ can be chosen arbitrarily as in case of star-connected \gls{pmsm}.
Applying Kirchhoff's current law at each terminal of delta-connected \gls{pmsm} gives
\begin{alignat}{1}
	i_{\textrm{as}} \meq i_{\textrm{a}} - i_{\textrm{c}}, \\
	i_{\textrm{bs}} \meq i_{\textrm{b}} - i_{\textrm{a}}, \\
	i_{\textrm{cs}} \meq i_{\textrm{c}} - i_{\textrm{b}}. 
\end{alignat}
The inverse relationship is obtained using the balanced conditions of the phase currents as
\begin{alignat}{1}
	i_{\textrm{a}} \meq \frac{1}{3}(i_{\textrm{as}} - i_{\textrm{bs}}), \\
	i_{\textrm{b}} \meq \frac{1}{3}(i_{\textrm{bs}} - i_{\textrm{cs}}), \\
	i_{\textrm{c}} \meq \frac{1}{3}(i_{\textrm{cs}} - i_{\textrm{as}}).
\end{alignat}
When the source currents are measured, the above transformation is required to obtain the phase currents.
Similarly, when given phase voltages are to be applied, they should be transformed to obtain required source voltages.
These transformations can be avoided by transforming motor parameters to star-connected \gls{pmsm} equivalent parameters and by changing the definition of the rotor angle.
By doing so, one can treat delta-connected \gls{pmsm} in the same way as star-connected \gls{pmsm}.
Details are provided in appendix \ref{app:NotesOnModel}.


% Figure
\begin{figure}[tb]
	\begin{center}
		\includegraphics[width=0.6\textwidth]{figs/pmsm_model_inverter/pmsm_model_inverter.pdf}
		\caption{\Gls{pmsm} connected to a simplified model of an inverter. \label{fig:PMSM_Inverter}}
	\end{center}
\end{figure}


% Inverter
In practice, a \gls{pmsm} is driven by an inverter connected to a \gls{dc} power supply.
Fig.~\ref{fig:PMSM_Inverter} shows \gls{pmsm} connected to a simplified model of an inverter.
Although one usually uses a single \gls{dc} power supply that provides $v_{\textrm{dc}}$ voltage between its terminals with one terminal being the neutral, it is convenient to choose the source neutral point $\textrm{N}$ in between as in fig.~\ref{fig:PMSM_Inverter}.
The control signals $S_{\textrm{ah}}$, $S_{\textrm{al}}$, $S_{\textrm{bh}}$, $S_{\textrm{bl}}$, $S_{\textrm{ch}}$, $S_{\textrm{cl}} \in \braCurl{0, 1}$ determine whether the respective switch is open or closed, and thus determine whether the respective motor phase is connected to $+v_{\textrm{dc}}/2$, $-v_{\textrm{dc}}/2$, or if it is left floating.


\subsection{Mechanical Equation}

% Equation governing the rotor angle
The rotor angle is governed by
\begin{alignat}{1}
	J\derivative{\omega}{t} \meq \tau_{\textrm{el}} + \tau_{\textrm{fr}} + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \label{eq:ModelMechanicalEq1}
\end{alignat}
where $J$ is the moment of inertia of the rotor, $\tau_{\textrm{el}}$ is electromagnetic torque generated by the stator currents, $\tau_{\textrm{fr}}$ is torque due to mechanical friction, $\tau_{\textrm{cog}}$ is cogging torque, and $\tau_{\textrm{ex}}$ is external torque applied to the rotor shaft. 


% Friction torque
The friction torque is 
\begin{alignat}{1}
	\tau_{\textrm{fr}} \meq -B\omega,
\end{alignat}
where $B$ is the coefficient of viscous friction.


% Electromagnetic torque
The electromagnetic torque is derived in appendix \ref{app:NotesOnModel} and it is
\begin{alignat}{1}
	\tau_{\textrm{el}} \meq
	\frac{1}{2}\bm{i}_{\textrm{abc}}\transpose\pderivative{\bm{L}}{\theta}\bm{i}_{\textrm{abc}} 
	+ \frac{1}{\omega}\bm{i}_{\textrm{abc}}\transpose\bm{e}_{\textrm{abc}}.
\end{alignat}
The first term is called reluctance torque and the second is called synchronous torque.
The reluctance torque is an effect of motor saliency and it is zero in \glspl{pmsm} with uniform air gap.
It can be shown that the electromagnetic torque is constant when the phase currents are sinusoidal functions of $\theta$.
Specifically, setting
\begin{alignat}{1}
	\bm{i}_{\textrm{abc}} \meq -I_{\textrm{m}}\begin{bmatrix}
		\sin\braRound{n_{\textrm{pp}}\theta} &
		\sin\braRound{n_{\textrm{pp}}\theta - \frac{2\pi}{3}} &
		\sin\braRound{n_{\textrm{pp}}\theta + \frac{2\pi}{3}}
	\end{bmatrix}\transpose\label{eq:Model_Optimal_Currents}
\end{alignat}
results in
\begin{alignat}{1}
	\tau_{\textrm{el}} \meq \frac{3}{2}n_{\textrm{pp}}\mathit{\Psi}_{\textrm{m}}I_{\textrm{m}}. \label{eq:Model_Optimal_Currents_torque}
\end{alignat}
Thus, the selected amplitude $I_{\textrm{m}}$ of the stator currents is proportional to the generated torque.
The current waveforms in \eqref{eq:Model_Optimal_Currents} are depicted in fig. \ref{fig:PMSM_Principle_b} for \gls{pmsm} with $n_{\textrm{pp}} = 1$.
More generally, setting
\begin{alignat}{1}
	\bm{i}_{\textrm{abc}} \meq -I_{\textrm{m}}\begin{bmatrix}
		\sin\braRound{n_{\textrm{pp}}\theta - \phi} &
		\sin\braRound{n_{\textrm{pp}}\theta - \phi- \frac{2\pi}{3}} &
		\sin\braRound{n_{\textrm{pp}}\theta - \phi+ \frac{2\pi}{3}}
	\end{bmatrix}\transpose\label{eq:Model_Optimal_Currents_phase_shift}
\end{alignat}
results in
\begin{alignat}{1}
	\tau_{\textrm{el}} \meq \frac{3}{2}n_{\textrm{pp}}\mathit{\Psi}_{\textrm{m}}I_{\textrm{m}}\cos{\phi} + \frac{9}{4} n_{\textrm{pp}}L_{\textrm{g}}I_{\textrm{m}}^2\sin(2\phi), \label{eq:Model_Optimal_Currents_torque_phase_shift}
\end{alignat}
where $\phi$ is constant phase shift.


% Cogging torque
The cogging torque $\tau_{\textrm{cog}}$ is another effect of the motor saliency.
It is torque that attracts the rotor to certain positions even when there are no currents running through the phase windings.
Many \glspl{pmsm} available on the market have a nominal value of cogging torque of \SI{5}{\percent}--\SI{10}{\percent} of the rated torque \cite{KrishnanBook}.
Cogging torque does not result directly from the mathematical model used here.
It can be left as an unknown component of the external torque $\tau_{\textrm{ex}}$, or it can be measured and accounted for.


\subsection{Resulting Model}

% Summary of the model
The model is now summarized and written as
\begin{alignat}{1}
	\bm{L}\derivative{\bm{i}_{\textrm{abc}}}{t} \meq
	- R_{\textrm{s}}\bm{i}_{\textrm{abc}} 
	- \omega\bm{L}^{\prime}\bm{i}_{\textrm{abc}}
	- \bm{e}_{\textrm{abc}}
	+ \bm{v}_{\textrm{abc}}, \label{eq:PMSM_Model_Resulting_Veq} \\
	J\derivative{\omega}{t} \meq \frac{1}{2}\bm{i}_{\textrm{abc}}\transpose\bm{L}^{\prime}\bm{i}_{\textrm{abc}} + \frac{1}{\omega}\bm{i}_{\textrm{abc}}\transpose\bm{e}_{\textrm{abc}} - B\omega + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \label{eq:PMSM_Model_Resulting_Meq} \\
	\derivative{\theta}{t} \meq \omega
\end{alignat}
where
\begin{alignat}{1}
	\bm{L}^{\prime} \meq \pderivative{\bm{L}}{\theta}.
\end{alignat}
From this model, the model of \gls{pmsm} with uniform air gap is obtained by setting $L_{\textrm{g}} = 0$ and $\tau_{\textrm{cog}} = 0$.



\newpage
\section{Two-Phase Equivalent Model}
The balanced conditions of three variables mean that only two of them can be chosen as independent.
For this reason, only two of the three voltage equations are needed and the third state variable may be computed from \eqref{eq:BalancedConditionsCurrents1}.
However, it is convenient to transform the equations using Clarke transformation.
The transformed variables are
\begin{alignat}{2}
	\bm{i}_{\upalpha\upbeta\upgamma} \meq \begin{bmatrix}
		i_{\upalpha} & i_{{\upbeta}} & i_{{\upgamma}}
	\end{bmatrix}\transpose \meq \bm{K} \bm{i}_{\textrm{abc}}, \\
	\bm{v}_{\upalpha\upbeta\upgamma} \meq \begin{bmatrix}
		v_{\upalpha} & v_{{\upbeta}} & v_{{\upgamma}}
	\end{bmatrix}\transpose \meq \bm{K} \bm{v}_{\textrm{abc}}, \\
	\bm{e}_{\upalpha\upbeta\upgamma} \meq \begin{bmatrix}
		e_{\upalpha} & e_{{\upbeta}} & e_{{\upgamma}}
	\end{bmatrix}\transpose \meq \bm{K} \bm{e}_{\textrm{abc}},
\end{alignat}
where the transformation matrix $K$ is defined as
\begin{alignat}{1}
	\bm{K} \meq \frac{2}{3}\begin{bmatrix}
		1 & -\frac{1}{2} & -\frac{1}{2} \cr
		0 & \frac{\sqrt{3}}{2} & - \frac{\sqrt{3}}{2} \cr
		\frac{1}{2} & \frac{1}{2} & \frac{1}{2}
	\end{bmatrix} \label{eq:PMSM_Model_Clarke_Transformation_Matrix}
\end{alignat}
with inverse matrix
\begin{alignat}{1}
	\bm{K}^{-1} \meq \begin{bmatrix}
		1 & 0 & 1 \cr
		-\frac{1}{2} & \frac{\sqrt{3}}{2} & 1 \cr
		-\frac{1}{2} & -\frac{\sqrt{3}}{2} & 1
	\end{bmatrix}. \label{eq:PMSM_Model_Clarke_Transformation_Inv_Matrix}
\end{alignat}
The first two components of the transformed vectors, $\upalpha$ and $\upbeta$, are two differential modes and the third component, $\upgamma$, is common mode of the abc varibles. Due to the balanced conditions, the $\upgamma$ components are always zero.
The voltage equation \eqref{eq:PMSM_Model_Resulting_Veq} is transformed by substituting in for the currents, voltages, and back \glspl{emf} and then  multiplying by $\bm{K}$ from the left.
The mechanical equation \eqref{eq:PMSM_Model_Resulting_Meq} is transformed by substituting in for the currents and back \glspl{emf}.
This results in
\begin{alignat}{1}
	\bm{L}_{\upalpha\upbeta\upgamma}\derivative{\bm{i}_{\upalpha\upbeta\upgamma}}{t} \meq
	- R_{\textrm{s}}\bm{i}_{\upalpha\upbeta\upgamma} 
	- \omega \bm{L}_{\upalpha\upbeta\upgamma}^{\prime}\bm{i}_{\upalpha\upbeta\upgamma}
	- \bm{e}_{\upalpha\upbeta\upgamma}
	+ \bm{v}_{\upalpha\upbeta\upgamma}, \label{eq:PMSM_Model_abg_voltage_eq}\\
	J\derivative{\omega}{t} \meq 
	\frac{1}{2}\bm{i}_{\upalpha\upbeta\upgamma}\transpose 
	\bm{K}\itranspose \bm{K}^{-1} \bm{L}_{\upalpha\upbeta\upgamma}^{\prime}\bm{i}_{\upalpha\upbeta\upgamma}
	+ \frac{1}{\omega}\bm{i}_{\upalpha\upbeta\upgamma}\transpose
	\bm{K}\itranspose\bm{K}^{-1}\bm{e}_{\upalpha\upbeta\upgamma}  \nonumber\\
	\meqskip - B\omega + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \label{eq:PMSM_Model_abg_mech_eq} \\
	\derivative{\theta}{t} \meq \omega,
\end{alignat}
where
\begin{alignat}{1}
	\bm{L}_{\upalpha\upbeta\upgamma} \meq \bm{K}\bm{L}_{\textrm{sal}}\bm{K}^{-1}, \\
	\bm{L}_{\upalpha\upbeta\upgamma}^{\prime} \meq \pderivative{\bm{L}_{\upalpha\upbeta\upgamma}}{\theta}.
\end{alignat}

As the current $i_{\upgamma}$ is always zero, it is not associated with any energy transfer and the corresponding equation can be dropped.
For this reason, one can use reduced Clarke transformation
\begin{alignat}{2}
	\bm{i}_{\upalpha\upbeta} \meq \begin{bmatrix}
		i_{\upalpha} & i_{{\upbeta}}
	\end{bmatrix}\transpose \meq \tilde{\bm{K}} \bm{i}_{\textrm{abc}}, \\
	\bm{v}_{\upalpha\upbeta} \meq \begin{bmatrix}
		v_{\upalpha} & v_{{\upbeta}}
	\end{bmatrix}\transpose \meq \tilde{\bm{K}} \bm{v}_{\textrm{abc}}, \\
	\bm{e}_{\upalpha\upbeta} \meq \begin{bmatrix}
		e_{\upalpha} & e_{{\upbeta}}
	\end{bmatrix}\transpose \meq \tilde{\bm{K}} \bm{e}_{\textrm{abc}},
\end{alignat}
where
\begin{alignat}{1}
	\tilde{\bm{K}} \meq \frac{2}{3}\begin{bmatrix}
		1 & -\frac{1}{2} & -\frac{1}{2} \cr
		0 & \frac{\sqrt{3}}{2} & - \frac{\sqrt{3}}{2}
	\end{bmatrix}.
\end{alignat}
The model is then written as
\begin{alignat}{1}
	\bm{L}_{\upalpha\upbeta}\derivative{\bm{i}_{\upalpha\upbeta}}{t} \meq
	- R_{\textrm{s}}\bm{i}_{\upalpha\upbeta} 
	- \omega \bm{L}_{\upalpha\upbeta}^{\prime}\bm{i}_{\upalpha\upbeta}
	- \bm{e}_{\upalpha\upbeta}
	+ \bm{v}_{\upalpha\upbeta}, \\
	J\derivative{\omega}{t} \meq 
	\frac{3}{4}\bm{i}_{\upalpha\upbeta}\transpose 
	\bm{L}_{\upalpha\upbeta}^{\prime}\bm{i}_{\upalpha\upbeta}
	+ \frac{3}{2\omega}\bm{i}_{\upalpha\upbeta}\transpose
	\bm{e}_{\upalpha\upbeta} 
	- B\omega + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \\
	\derivative{\theta}{t} \meq \omega,
\end{alignat}
where $\bm{L}_{\upalpha\upbeta}$ and $\bm{L}_{\upalpha\upbeta}^{\prime}$ are  obtained from $\bm{L}_{\upalpha\upbeta\upgamma}$ and $\bm{L}_{\upalpha\upbeta\upgamma}^{\prime}$ by taking only the first  two columns and the first two rows.
Inspecting
\begin{alignat}{1}
    \bm{L}_{\upalpha\upbeta} \meq
    \begin{bmatrix}
    	L_{\textrm{s}} + M_{\textrm{s}} & 0 \cr
    	0 & L_{\textrm{s}} + M_{\textrm{s}}
    \end{bmatrix} + \frac{3}{2}L_{\textrm{g}} 
    \begin{bmatrix}
         \cos (2n_{\textrm{pp}}\theta) &
         \sin (2n_{\textrm{pp}}\theta) \cr
         \sin (2n_{\textrm{pp}}\theta) &
         -\cos (2n_{\textrm{pp}}\theta)
    \end{bmatrix}, \\
    \bm{L}_{\upalpha\upbeta}^{\prime} \meq 
	3 n_{\textrm{pp}} L_{\textrm{g}}
    \begin{bmatrix}
        -\sin (2n_{\textrm{pp}}\theta) &
        \cos (2n_{\textrm{pp}}\theta) \cr
        \cos (2n_{\textrm{pp}}\theta) &
        \sin (2n_{\textrm{pp}}\theta)
    \end{bmatrix}, \\
    \bm{e}_{\upalpha\upbeta} \meq
     - n_{\textrm{pp}} \omega \mathit{\Psi}_{\textrm{m}}
    \begin{bmatrix}
        \sin(n_{\textrm{pp}} \theta) &
        -\cos(n_{\textrm{pp}} \theta)
    \end{bmatrix}\transpose
\end{alignat}
gives an insight into the transformed model.
The model in $\upalpha\upbeta$ variables is very similar to the model of two-phase \gls{pmsm} with the two phases orthogonal to each other and magnetic axis of phase $\upalpha$ is aligned with magnetic axis of phase A.
Phase $\upbeta$ is rotated in space by $+90$ degrees from phase $\upalpha$.
The difference is in the electromagnetic torque, which greater by a factor of 3/2 due to the fact that Clark transformation is not unitary and it does not preserve the magnitude of the transformed vectors. 


The $\upalpha\upbeta$ variables are two differential modes of the abc variables and it is possible to obtain the transformed voltages by applying the Clarke transformation directly to the source voltages
\begin{alignat}{1}
	\bm{v}_{\upalpha\upbeta} \meq
	\tilde{\bm{K}}\begin{bmatrix}
		v_{\textrm{as}} & v_{\textrm{bs}} & v_{\textrm{cs}}
	\end{bmatrix}\transpose.
\end{alignat}
Further notes on the Clarke transformation are given in appendix \ref{app:NotesOnModel}.


\section{Transformation to DQ Variables}
The model is further simplified by expressing $\upalpha\upbeta\gamma$ variables in a rotating reference frame fixed to the rotor.
In the resulting model, the dependence on the rotor angle is eliminated.
This is done using Park transformation
\begin{alignat}{2}
	\bm{i}_{\textrm{dqz}} \meq \begin{bmatrix}
		i_{\textrm{d}} & i_{{\textrm{q}}} & i_{\textrm{z}}
	\end{bmatrix}\transpose \meq \bm{R}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta} \bm{i}_{\upalpha\upbeta\upgamma}, \\
	\bm{v}_{\textrm{dqz}} \meq \begin{bmatrix}
		v_{\textrm{d}} & v_{{\textrm{q}}} & v_{\textrm{z}}
	\end{bmatrix}\transpose \meq \bm{R}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta} \bm{v}_{\upalpha\upbeta\upgamma}, \\
	\bm{e}_{\textrm{dqz}} \meq \begin{bmatrix}
		e_{\textrm{d}} & e_{{\textrm{q}}} & e_{\textrm{z}}
	\end{bmatrix}\transpose \meq \bm{R}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta} \bm{e}_{\upalpha\upbeta\upgamma},
\end{alignat}
where the rotation matrix is
\begin{alignat}{1}
	\bm{R}_{\textrm{z}}\braRound{\varphi} \meq \begin{bmatrix}
	 \cos\braRound{\varphi} & \sin\braRound{\varphi} & 0 \\
	-\sin\braRound{\varphi} & \cos\braRound{\varphi} & 0 \\
	                      0 &                      0 & 1
	\end{bmatrix}.
\end{alignat}
The first component of the transformed variables is called direct component, the second is called quadrature component, and the third is called zero component.

The voltage equation \eqref{eq:PMSM_Model_abg_voltage_eq} is transformed by substituting in for the currents, voltages, and back \glspl{emf} and then  multiplying by $\bm{R}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta}$ from the left.
The mechanical equation~\eqref{eq:PMSM_Model_abg_mech_eq} is transformed by substituting in for the currents and back \glspl{emf}.
This results in
\begin{alignat}{1}
	\bm{L}_{\textrm{dqz}}\derivative{\bm{i}_{\textrm{dqz}}}{t} \meq
	- R_{\textrm{s}}\bm{i}_{\textrm{dqz}} 
	- \omega \dtilde{\bm{L}}_{\textrm{dqz}}\bm{i}_{\textrm{dqz}}
	- \bm{e}_{\textrm{dqz}}
	+ \bm{v}_{\textrm{dqz}}, \\
	J\derivative{\omega}{t} \meq 
	\frac{1}{2}\bm{i}_{\textrm{dqz}}\transpose 
	\bm{K}\itranspose \bm{K}^{-1} \tilde{\bm{L}}_{\textrm{dqz}}\bm{i}_{\textrm{dqz}}
	+ \frac{1}{\omega}\bm{i}_{\textrm{dqz}}\transpose
	\bm{K}\itranspose\bm{K}^{-1}\bm{e}_{\textrm{dqz}}  \nonumber\\
	\meqskip - B\omega + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \\
	\derivative{\theta}{t} \meq \omega,
\end{alignat}
where
\begin{alignat}{1}
	\bm{L}_{\textrm{dqz}} \meq 
\bm{R}_{\textrm{z}}\bm{L}_{\upalpha\upbeta\upgamma}
\bm{R}_{\textrm{z}}^{-1}, \\
	\tilde{\bm{L}}_{\textrm{dqz}} \meq \bm{R}_{\textrm{z}}\bm{L}_{\upalpha\upbeta\upgamma}^{\prime}\bm{R}_{\textrm{z}}^{-1}, \\
	\dtilde{\bm{L}}_{\textrm{dqz}} \meq \tilde{\bm{L}}_{\textrm{dqz}} + \bm{R}_{\textrm{z}}\bm{L}_{\upalpha\upbeta\upgamma}\pderivative{\bm{R}_{\textrm{z}}^{-1}}{\theta}.
\end{alignat}

As the third component of the transformed variables is zero and the equation for $i_{\textrm{z}}$ can be dropped, the transformation can be done for the direct and quadrature components only
\begin{alignat}{2}
	\bm{i}_{\textrm{dq}} \meq \begin{bmatrix}
		i_{\textrm{d}} & i_{{\textrm{q}}}
	\end{bmatrix}\transpose \meq \tilde{\bm{R}}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta} \bm{i}_{\upalpha\upbeta}, \\
	\bm{v}_{\textrm{dq}} \meq \begin{bmatrix}
		v_{\textrm{d}} & v_{{\textrm{q}}}
	\end{bmatrix}\transpose \meq \tilde{\bm{R}}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta} \bm{v}_{\upalpha\upbeta}, \\
	\bm{e}_{\textrm{dq}} \meq \begin{bmatrix}
		e_{\textrm{d}} & e_{{\textrm{q}}}
	\end{bmatrix}\transpose \meq \tilde{\bm{R}}_{\textrm{z}}\braRound{n_{\textrm{pp}}\theta} \bm{e}_{\upalpha\upbeta},
\end{alignat}
where the rotation matrix is
\begin{alignat}{1}
	\tilde{\bm{R}}_{\textrm{z}}\braRound{\varphi} \meq \begin{bmatrix}
	 \cos\braRound{\varphi} & \sin\braRound{\varphi}\\
	-\sin\braRound{\varphi} & \cos\braRound{\varphi}
	\end{bmatrix}.
\end{alignat}
The model is then written as
\begin{alignat}{1}
	\bm{L}_{\textrm{dq}}\derivative{\bm{i}_{\textrm{dq}}}{t} \meq
	- R_{\textrm{s}}\bm{i}_{\textrm{dq}} 
	- \omega \dtilde{\bm{L}}_{\textrm{dq}}\bm{i}_{\textrm{dq}}
	- \bm{e}_{\textrm{dq}}
	+ \bm{v}_{\textrm{dq}}, \\
	J\derivative{\omega}{t} \meq 
	\frac{3}{4}\bm{i}_{\textrm{dq}}\transpose 
	\tilde{\bm{L}}_{\textrm{dq}}\bm{i}_{\textrm{dq}}
	+ \frac{3}{2\omega}\bm{i}_{\textrm{dq}}\transpose
	\bm{e}_{\textrm{dq}} - B\omega + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \\
	\derivative{\theta}{t} \meq \omega,
\end{alignat}
where 
\begingroup
\allowdisplaybreaks
\begin{alignat}{1}
	\bm{L}_{\textrm{dq}} \meq
	\begin{bmatrix}
        L_{\textrm{s}} + M_{\textrm{s}} + \frac{3}{2} L_{\textrm{g}} &
        0 \cr
        0 &
        L_{\textrm{s}} + M_{\textrm{s}} - \frac{3}{2} L_{\textrm{g}}
    \end{bmatrix}, \\
	\tilde{\bm{L}}_{\textrm{dq}} \meq
	3 n_{\textrm{pp}}	
	\begin{bmatrix}
        0 &
        L_{\textrm{g}}  \cr
        L_{\textrm{g}}  &
        0
    \end{bmatrix}, \\
	\dtilde{\bm{L}}_{\textrm{dq}} \meq
	n_{\textrm{pp}}	
	\begin{bmatrix}
        0 &
        -\braRound{L_{\textrm{s}} + M_{\textrm{s}} - \frac{3}{2}L_{\textrm{g}}} \cr
        L_{\textrm{s}} + M_{\textrm{s}} + \frac{3}{2} L_{\textrm{g}} &
        0
    \end{bmatrix} \\
	\bm{e}_{\textrm{dq}} \meq
	n_{\textrm{pp}}	\omega \mathit{\Psi}_{\textrm{m}}
	\begin{bmatrix}
        0 & 1
    \end{bmatrix}\transpose.
\end{alignat}
\endgroup
The direct and quadrature inductances are defined as
\begin{alignat}{1}
	L_{\textrm{d}} \meq L_{\textrm{s}} + M_{\textrm{s}} + \frac{3}{2} L_{\textrm{g}}, \label{eq:Model_Ld_def}\\
	L_{\textrm{q}} \meq L_{\textrm{s}} + M_{\textrm{s}} - \frac{3}{2} L_{\textrm{g}}\label{eq:Model_Lq_def}. 
\end{alignat}
The back-EMF constant is defined as
\begin{alignat}{1}
	K_{\textrm{b}} \meq n_{\textrm{pp}}	\mathit{\Psi}_{\textrm{m}}. \label{eq:PMSM_Kb_def}
\end{alignat}
The DQ model of \gls{pmsm} is then expressed in scalar form as
\begin{alignat}{1}
	L_{\textrm{d}}\derivative{i_{\textrm{d}}}{t} \meq 
	- R_{\textrm{s}}i_{\textrm{d}}
	+ n_{\textrm{pp}}\omega L_{\textrm{q}}i_{\textrm{q}}
	+ v_{\textrm{d}}, \\
	L_{\textrm{q}}\derivative{i_{\textrm{q}}}{t} \meq 
	- R_{\textrm{s}}i_{\textrm{q}}
	- n_{\textrm{pp}}\omega L_{\textrm{d}}i_{\textrm{d}}
	- K_{\textrm{b}}\omega
	+ v_{\textrm{q}}, \\
	J\derivative{\omega}{t} \meq
	\frac{3}{2}n_{\textrm{pp}}i_{\textrm{d}}i_{\textrm{q}}(L_{\textrm{d}} - L_{\textrm{q}})
	+ \frac{3}{2} K_{\textrm{b}}i_{\textrm{q}}
	- B\omega + \tau_{\textrm{cog}} + \tau_{\textrm{ex}}, \\
	\derivative{\theta}{t} \meq \omega.
\end{alignat}
From this model, model of \gls{pmsm} with uniform air gap is obtained by setting $L_{\textrm{d}} = L_{\textrm{q}}$ and $\tau_{\textrm{cog}} = 0$.
The main component of the electromagnetic torque is the synchronous torque $3K_{\textrm{b}}i_{\textrm{q}}/2$ and the reluctance torque $3n_{\textrm{pp}}i_{\textrm{d}}i_{\textrm{q}}(L_{\textrm{d}} - L_{\textrm{q}})/2$ is usually significantly smaller.
In other words, the electromagnetic torque is primarily produced by the quadrature current $i_{\textrm{q}}$ alone.
The direct current $i_{\textrm{d}}$ creates magnetic field aligned with the rotor magnetic field and does not produce significant torque.
At low speeds, the direct current is usually commanded to zero. 
At high speeds, it is commanded to negative values to weaken the rotor magnetic field in order to decrease the voltage induced in the quadrature phase.

In steady state with constant rotor speed and sinusoidal phase currents given in \eqref{eq:Model_Optimal_Currents}, the direct current is zero and the quadrature current is the amplitude of the phase currents.
More generally, if the steady-state currents are as given in \eqref{eq:Model_Optimal_Currents_phase_shift}, then
\begin{alignat}{1}
	i_{\textrm{d}} \meq I_{\textrm{m}}\sin(\phi), \\
	i_{\textrm{q}} \meq I_{\textrm{m}}\cos(\phi).
\end{alignat}



\section{Linearized Model}

% Linearization
For control purposes, the DQ model of \gls{pmsm} is linearized into the following standard state-space form
\begin{alignat}{1}
	\dot{\bm{x}} \meq \bm{A}_{\textrm{c}}\bm{x} + \bm{B}_{\textrm{c}}\bm{u}, \\
	\bm{y} \meq \bm{C}_{\textrm{c}}\bm{x} + \bm{D}_{\textrm{c}}\bm{u},
\end{alignat}
where the state vector and input vector are
\begin{alignat}{1}
	\bm{x} \meq \begin{bmatrix}
		i_{\textrm{d}} &
		i_{\textrm{q}} &
		\omega &
		\theta
	\end{bmatrix}\transpose, \\
	\bm{u} \meq \begin{bmatrix}
		v_{\textrm{d}} &
		v_{\textrm{q}}
	\end{bmatrix}\transpose.
\end{alignat}
The cogging torque and the external torque are not considered in this model.
The linear DQ model is obtained by making a two assumptions and approximations, which simplify the nonlinear model into a linear one.
Firstly, the reluctance torque is neglected as it is usually small compared to the synchronous torque.
Secondly, it is assumed that $\omega$ does not change too much during controller sampling period, or over the prediction horizon in case of \gls{mpc}.
This justifies one to consider $\omega$ a constant parameter in the nonlinear terms $n_{\textrm{pp}}\omega L_{\textrm{q}}i_{\textrm{q}}$ and $n_{\textrm{pp}}\omega L_{\textrm{d}}i_{\textrm{d}}$.
This gives linear time-varying model 
\begin{alignat}{2}
	\bm{A}_{\textrm{c}} \meq \begin{bmatrix}
		-\dfrac{R_{\textrm{s}}}{L_{\textrm{d}}} &
		 n_{\textrm{pp}}\omega \dfrac{L_{\textrm{q}}}{L_{\textrm{d}}} &
		 0 &
		 0 \\[1.3ex]
		-n_{\textrm{pp}}\omega \dfrac{L_{\textrm{d}}}{L_{\textrm{q}}} &
		-\dfrac{R_{\textrm{s}}}{L_{\textrm{q}}} &
		 -\dfrac{K_{\textrm{b}}}{L_{\textrm{q}}} &
		 0 \\[1.3ex]
		 0 &
		 \dfrac{3}{2}\dfrac{K_{\textrm{b}}}{J} &
		 -\dfrac{B}{J} &
		 0 \\[1.3ex]
		 0 & 0 & 1 & 0
	\end{bmatrix}, \label{eq:PMSM_Linear_A} 
	\bm{B}_{\textrm{c}} \meq \begin{bmatrix}
		\dfrac{1}{L_{\textrm{d}}} & 0 \\[1.3ex]
		0 & \dfrac{1}{L_{\textrm{q}}} \\[1.3ex]
		0 & 0 \\[1.3ex]
		0 & 0
	\end{bmatrix} %\label{eq:PMSM_Linear_B}
\end{alignat}
parametrized by $\omega$.
Matrix $\bm{D}_{\textrm{c}} = \bm{0}$ is zero matrix and $\bm{C}_{\textrm{c}}$ is chosen based on the control objective. 
Such linearized model was also used in \cite{BeldaOnlineMPC}. 



\section{Discretization}
Discrete-time linear model of \gls{pmsm} with sampling period $T_{\textrm{s}}$
\begin{alignat}{1}
	\bm{x}_{k+1} \meq \bm{A}_{\textrm{d}}\bm{x}_{k} + \bm{B}_{\textrm{d}}\bm{u}_{k}, \\
	\bm{y}_{k} \meq \bm{C}_{\textrm{d}}\bm{x}_{k} + \bm{D}_{\textrm{d}}\bm{u}_{k}
\end{alignat}
is obtained from the continuous-time model assuming constant inputs over the sampling period, which results in
\begin{alignat}{1}
	\bm{A}_{\textrm{d}} \meq e^{T_{\textrm{s}}\bm{A}_{\textrm{c}}}, \\
	\bm{B}_{\textrm{d}} \meq \braRound{\int\limits_{\tau=0}^{\tau=T_{\textrm{s}}}e^{\tau\bm{A}_{\textrm{c}}}\diff{\tau}}\bm{B}_{\textrm{c}}, \\
	\bm{C}_{\textrm{d}} \meq \bm{C}_{\textrm{c}}, \\
	\bm{D}_{\textrm{d}} \meq \bm{D}_{\textrm{c}}.
\end{alignat}
When the discrete-time state-space matrices are to be computed online within a limited amount of time, Euler approximation
\begin{alignat}{1}
	\bm{A}_{\textrm{d}} \mapprox \bm{I} + T_{\textrm{s}}\bm{A}_{\textrm{c}}, \\
	\bm{B}_{\textrm{d}} \mapprox T_{\textrm{s}}\bm{B}_{\textrm{c}}
\end{alignat}
can be used.




\section{Model Parameters \label{sec:ch2ModelParameters}}

% Datasheet values
Usually, datasheets provide only line-to-line inductance $L_{\textrm{line-line}}$, line-to-line resistance $R_{\textrm{line-line}}$, and torque constant $K_{\textrm{t}}$ or line-to-line back-\gls{emf} constant $K_{\textrm{b}}^{\textrm{line-line}}$.
The relationships between the datasheet parameters and the model parameters are presented in \cite{ChiassonBook}.
However, the DQ model in \cite{ChiassonBook} is derived using different Clarke transformation and different definition of the back-\gls{emf} constant than the one used here.
For the sake of completeness and to make things clear, the same procedure as in \cite{ChiassonBook} is adapted for the parameters used here.

Now, star-connected \gls{pmsm} with uniform air gap is assumed.
The direct and quadrature inductances are equal $L=L_{\textrm{d}}=L_{\textrm{q}}$.
The line-to-line inductance and resistance are measured with locked rotor by applying voltage between two terminal, e.g. A and B, and the third terminal is left unconnected.
Thus, $\omega = 0$, $i_{\textrm{c}} = 0$, and $i_{\textrm{b}} = -i_{\textrm{a}}$.
The equations for $i_{\textrm{a}}$ and $i_{\textrm{b}}$ are obtained from \eqref{eq:PMSM_Model_Resulting_Veq} by substituting in for $\omega$ are
\begin{eqnarray}
	L_{\textrm{s}}\derivative{i_{\textrm{a}}}{t} - M_{\textrm{s}}\derivative{i_{\textrm{b}}}{t}
	\meq -R_{\textrm{s}}i_{\textrm{a}} + v_{\textrm{a}},\\
	-M_{\textrm{s}}\derivative{i_{\textrm{a}}}{t} + L_{\textrm{s}}\derivative{i_{\textrm{b}}}{t}
	\meq -R_{\textrm{s}}i_{\textrm{b}} + v_{\textrm{b}}.
\end{eqnarray}
Substituting in $i_{\textrm{b}} = -i_{\textrm{a}}$ and substracting the second equation from the first one gives
\begin{alignat}{1}
	2(L_{\textrm{s}} + M_{\textrm{s}})\derivative{i_{\textrm{a}}}{t} \meq -2R_{\textrm{s}} + (v_{\textrm{a}} -  v_{\textrm{b}}).
\end{alignat}
Therefore, the line-to-line inductance and resistance are
\begin{alignat}{1}
	L_{\textrm{line-line}} \meq 2(L_{\textrm{s}} + M_{\textrm{s}}), \\
	R_{\textrm{line-line}} \meq 2R_{\textrm{s}}.
\end{alignat}
Comparing the line-to-line inductance with the definition of $L_{\textrm{d}}$ in \eqref{eq:Model_Ld_def} and definition of $L_{\textrm{q}}$ in \eqref{eq:Model_Lq_def} gives
\begin{alignat}{1}
	L \meq L_{\textrm{d}} \meqna L_{\textrm{q}} \meqna \frac{1}{2}L_{\textrm{line-line}}, \\
	R_{\textrm{s}} \meq \frac{1}{2}R_{\textrm{line-line}}.
\end{alignat}
The line-to-line back-\gls{emf} constant is measured by leaving all motor terminals unconnected and rotating the rotor at constant speed using another motor.
Thus, $i_{\textrm{a}} = i_{\textrm{b}} = i_{\textrm{c}} = 0$.
The induced voltage is measured between two terminals, e.g. B and C.
The equations for $v_{\textrm{b}}$ and $v_{\textrm{c}}$ are obtained from \eqref{eq:PMSM_Model_Resulting_Veq} by substituting in for the currents
\begin{alignat}{1}
	v_{\textrm{b}} \meq n_{\textrm{pp}}\omega\mathit{\Psi}_{\textrm{m}}\sin\braRound{n_{\textrm{pp}}\theta - \frac{2\pi}{3}}, \\
	v_{\textrm{c}} \meq n_{\textrm{pp}}\omega\mathit{\Psi}_{\textrm{m}}\sin\braRound{n_{\textrm{pp}}\theta + \frac{2\pi}{3}}.
\end{alignat}
Substracting the second equation from the first one and rearranging gives
\begin{alignat}{1}
	\frac{v_{\textrm{b}} - v_{\textrm{b}}}{\omega} \meq \sqrt{3}n_{\textrm{pp}}\mathit{\Psi}_{\textrm{m}}\cos\braRound{n_{\textrm{pp}}\theta}.
\end{alignat}
Therefore, the line-to-line back-\gls{emf} constant relating the amplitude of the induced line-to-line voltage to the rotor speed is
\begin{alignat}{1}
	K_{\textrm{b}}^{\textrm{line-line}} \meq \sqrt{3}n_{\textrm{pp}}\mathit{\Psi}_{\textrm{m}}.
\end{alignat}
Comparing with the definition of $K_{\textrm{b}}$ in \eqref{eq:PMSM_Kb_def} gives
\begin{alignat}{1}
	K_{\textrm{b}} \meq \frac{1}{\sqrt{3}}K_{\textrm{b}}^{\textrm{line-line}}.
\end{alignat}
The torque constant relates the generated electromagnetic torque to the \gls{rms} value of the source currents in steady state when the currents are sinusoidal and synchronized with the rotor as in \eqref{eq:Model_Optimal_Currents}.
Such currents result in constant torque given in \eqref{eq:Model_Optimal_Currents_torque}.
Thus, the torque constant is
\begin{alignat}{1}
	K_{\textrm{t}} \meq \sqrt{2}\frac{3}{2}n_{\textrm{pp}}\mathit{\Psi}_{\textrm{m}}
\end{alignat}
and
\begin{alignat}{1}
	K_{\textrm{b}} \meq \frac{1}{\sqrt{2}}\frac{2}{3}K_{\textrm{t}}.
\end{alignat}
Both $K_{\textrm{b}}^{\textrm{line-line}}$ and $K_{\textrm{b}}$ have units of $\si[per-mode=symbol]{\Vpeak\per(\radian\per\second)} = \si[per-mode=symbol]{\newton\meter\per\Apeak}$
whereas $K_{\textrm{t}}$ has unit of $\si[per-mode=symbol]{\Vrms\per(\radian\per\second)} = \si[per-mode=symbol]{\newton\meter\per\Arms}$.
However, some datasheets give the torque constant using the peak current and/or the line-to-line back-\gls{emf} constant using the \gls{rms} voltage.
When motor saliency is to be considered, one usually has to identify the inductances $L_{\textrm{d}}$ and $L_{\textrm{q}}$ as they are not usually provided by the manufacturer.


% Delta-connected PMSM
Similar but slightly modified steps can be taken for delta-connected \gls{pmsm} to find the relationships between the datasheet parameters and the parameters used here.
Another approach is to treat the motor as star-connected and the star-equivalent parameters are obtained in the same way as for an actual star-connected \gls{pmsm}.
This is justified in appendix~\ref{app:NotesOnModel}.


% Parameters of used motor
The control algorithms inspected in this thesis were evaluated on \gls{pmsm} BLWR233D-36V-4000 by Anaheim Automation. (According to the manufacturer it is \gls{bldc} motor, however, according to the terminology used here, it is rather \gls{pmsm}.)
The motor is delta-connected but it was treated as star-connected using star-equivalent parameters.
The parameters given in datasheet \cite{MotorDatasheet} are in tab. \ref{tab:PMSM_Datasheet_Params}.
The motor is designed such that it can continuously operate at rated conditions without overheating.
At the rated conditions, the motor is controlled such that it rotates at the rated speed with an external load torque equal to the rated torque, $\tau_{\textrm{ex}} = \SI{-0.22}{\newton\meter}$.
The rated current is the steady-state \gls{rms} value of the source currents running to the motor terminals.
The generated electromagnetic torque equals the rated current times the torque constant and is approximately equal to the rated torque.
There is, however, a small component of the electromagnetic torque that compensates for the friction.
As the coefficient of viscous friction is not given in the datasheet, one might try to estimate $B$ from the precision of the rated values assigning the difference between the electromagnetic torque and the load torque to the friction torque.
This would, however, provide very inaccurate and uncertain value and one should rather identify $B$ experimentally.
% Not very precise method
%one can estimate the upper bound from the precision of the rated values.
%For example, assume that the rated current was actually \SI{0.005}{\Arms} greater and that the /%rated torque was actually \SI{0.05}{\ouncef\inch} smaller.
%The upper bound on $B$ is then calculated from $\tau_{\textrm{el}} + \tau_{\textrm{fr}} + \tau_{\textrm{ex}} = 0$ and $\tau_{\textrm{fr}} = -B\omega$.
The rated voltage is recommended inverter \gls{dc}-bus voltage $v_{\textrm{dc}}$.

For the control design, experimentally identified star-equivalent parameters were used.
The identification method used to obtain these parameters was similar to the one in \cite{NXPPMSMMEasurements}.
The identified parameters and parameters derived from the datasheet are in tab.~\ref{tab:PMSM_Identified_Params}.
\begin{table}[htb!]%
	\centering
	\begin{tabularx}{\textwidth}{lCC}
		\toprule
 		Parameter & Given value & Converted to SI \\
 		\midrule
 		Number of poles         & 4 & 4 \\
 		Rated voltage           & \SI{36}{\volt} & \SI{36}{\volt} \\
 		Rated speed             & \SI{4000}{\rpm} & \SI{418.9}{\radian\per\second} \\
 		Rated power             & \SI{92}{\watt} & \SI{92}{\watt} \\
 		Rated torque            & \SI{31.2}{\ouncef\inch} & \SI{0.22}{\newton\meter} \\
 		Peak torque             & \SI{93.5}{\ouncef\inch} & \SI{0.66}{\newton\meter} \\
 		Rated current           & \SI{3.67}{\Arms} & \SI{3.67}{\Arms} \\
 		Line-to-line resistance & \SI{0.64}{\ohm} & \SI{0.64}{\ohm} \\
 		Line-to-line inductance & \SI{2.1}{\milli\henry} & \SI{2.1}{\milli\henry} \\
 		Torque constant         & \SI{8.50}{\ouncef\inch\per\Arms} & \SI{0.06}{\newton\meter\per\Arms} \\
 		Rotor inertia           & \US[group-digits = false]{0.00169}{\ouncef\inch\second\squared} & \SI{1.19e-5}{\kilo\gram\meter\squared} \\
 		\bottomrule
	\end{tabularx}
	\caption{Parameters given in datasheet for BLWR233D-36V-4000 motor.\label{tab:PMSM_Datasheet_Params}}
	\vspace*{0.75cm}
	\centering
	\begin{tabularx}{\textwidth}{lcCCC}
		\toprule
 		Parameter & Symbol & Identified & From datasheet & Unit \\
 		\midrule
 		Number of pole pairs & $n_{\textrm{pp}}$ & 2 & 2 & 1 \\
 		Phase resistance & $R_{\textrm{s}}$ & 0.45 & 0.32 & \si{\ohm}\\
 		Direct inductance & $L_{\textrm{d}}$ & 0.8 & 1.05 & \si{\milli\henry}\\
 		Quadrature inductance & $L_{\textrm{q}}$ & 0.9 & 1.05 & \si{\milli\henry} \\
 		Back-\gls{emf} constant & $K_{\textrm{b}}$ & 0.23 & 0.028 & \si{\Vpeak\per(\radian\per\second)} \\
 		Rotor inertia & $J$ & \SI{2.8e-5} & \SI{1.19e-5} & \si{\kilo\gram\meter\squared} \\
 		Friction coefficient & $B$ & \SI{1.3e-5} & -- & \si{\newton\meter\per(\radian\per\second)} \\
 		\bottomrule
	\end{tabularx}
	\caption{Star-equivalent parameters identified experimentally and derived from datasheet. \label{tab:PMSM_Identified_Params}}
\end{table}




\section{Constraints}


% Current constarints
\Gls{pmsm} manufacturers usually state two constraints on the currents supplied to the motor terminals.
The first one is the rated current, which is the maximum current at which the motor can operate continuously without overheating.
The second one is the peak current, which can be supplied to the motor terminals for short period of time.
Thus, the current can be increased above the rated current up to the peak current for certain amount of time and then it must not exceed the rated current for some other amount of time to prevent overheating.
To simplify the control task, single hard constraint is imposed on the phase currents using the fact that the phase currents are equal to the source currents when star-connected \gls{pmsm} model is used.
As the motor is to be operated both at high speeds with sinusoidal phase curents and at speeds close to zero with almost constant currents, the \gls{rms} value of the rated current is used as the limit on the instantaneous values of the phase currents.
Although this conservative choice reduces the maximum admissible torque at the rated speed, it enables simple formulation of the constraints
\begin{alignat}{1}
	\abs{i_{\textrm{a}}} \mleq I_{\textrm{max}}, \\
	\abs{i_{\textrm{b}}} \mleq I_{\textrm{max}}, \\
	\abs{i_{\textrm{c}}} \mleq I_{\textrm{max}}, \\
	I_{\textrm{max}} \meq \SI{3.67}{\ampere}.
\end{alignat}
The Clarke transformation translates these constraints to 
\begin{alignat}{1}
	\abs{i_{\upalpha}} \mleq I_{\textrm{max}}, \\
	\abs{i_{\upalpha} + \sqrt{3}i_{\upbeta}} \mleq 2I_{\textrm{max}}, \\
	\abs{i_{\upalpha} - \sqrt{3}i_{\upbeta}} \mleq 2I_{\textrm{max}},
\end{alignat}
which is area bounded by a hexagon as shown in fig. \ref{fig:PMSMConstraintsCab}.
In order to transform this feasible region to the rotating reference frame it is approximated by inscribed disk
\begin{alignat}{1}
	i_{\upalpha}^2 + i_{\upbeta}^2 \mleq I_{\textrm{max}}^2.
\end{alignat}
The disk remains unchanged when Park transformation is applied and it is written in the DQ variables as
\begin{alignat}{1}
	i_{\textrm{d}}^2 + i_{\textrm{q}}^2 \mleq I_{\textrm{max}}^2.
\end{alignat}
This nonlinear constraint is further approximated by set of linear constraints.
Specifically, octagon is used as the approximated feasible region in a similar way as in \cite{CiminiMPCOnlinePMSM}.
The octagon is in fig.~\ref{fig:PMSMConstraintsCDQ} and is described by
%\begin{alignat}{1}
%	\abs{i_{\textrm{d}} + (\sqrt{2}-1)i_{\textrm{q}}} \mleq I_{\textrm{max}}, \\
%	\abs{i_{\textrm{d}} - (\sqrt{2}-1)i_{\textrm{q}}} \mleq I_{\textrm{max}}, \\
%	\abs{(\sqrt{2}-1)i_{\textrm{d}} + i_{\textrm{q}}} \mleq I_{\textrm{max}}, \\
%	\abs{(\sqrt{2}-1)i_{\textrm{d}} - i_{\textrm{q}}} \mleq I_{\textrm{max}},
%\end{alignat}
%or using matrix formulation
\begin{alignat}{1}
	\bm{P}_{x}\bm{x} \mleq \bm{p}_{x},
\end{alignat}
where
\begingroup
\renewcommand*{\arraystretch}{0.75}
\begin{alignat}{2}
	\bm{P}_{x} \meq \begin{bmatrix}
		      +1 &   +\sqrt{2}-1 & 0 & 0 \cr
              +1 &   -\sqrt{2}+1 & 0 & 0 \cr
              -1 &   +\sqrt{2}-1 & 0 & 0 \cr
              -1 &   -\sqrt{2}+1 & 0 & 0 \cr
     +\sqrt{2}-1 &            +1 & 0 & 0 \cr
     +\sqrt{2}-1 &            -1 & 0 & 0 \cr
     -\sqrt{2}+1 &            +1 & 0 & 0 \cr
     -\sqrt{2}+1 &            -1 & 0 & 0
	\end{bmatrix}, \quad
	\bm{p}_{x} = \begin{bmatrix}
		I_{\textrm{max}} \cr
		I_{\textrm{max}} \cr
		I_{\textrm{max}} \cr
		I_{\textrm{max}} \cr
		I_{\textrm{max}} \cr
		I_{\textrm{max}} \cr
		I_{\textrm{max}} \cr
		I_{\textrm{max}}
	\end{bmatrix}. \label{eq:PMSM_constraint_x}
\end{alignat}
\endgroup
In this thesis, no constraints are imposed on the other two state variables, the rotor velocity and position.


% Voltage constarints
Assuming that the inverter always connects each phase to either $+v_{\textrm{dc}}/2$ or $-v_{\textrm{dc}}/2$ and that no phase is left unconnected, there are 8 possible voltage vectors that can be applied to the motor.
When modulation stage is used, one can assume that each source voltage is a real value from interval $[-v_{\textrm{dc}}/2, +v_{\textrm{dc}}/2]$.
Thus, constraints on the source voltages are
\begin{alignat}{1}
	\abs{v_{\textrm{as}}} \mleq \frac{1}{2} v_{\textrm{dc}}, \\
	\abs{v_{\textrm{bs}}} \mleq \frac{1}{2} v_{\textrm{dc}}, \\
	\abs{v_{\textrm{cs}}} \mleq \frac{1}{2} v_{\textrm{dc}},
\end{alignat}
where $v_{\textrm{dc}} = \SI{24}{\volt}$ was chosen instead of the rated voltage.
These constraints are translated by the Clarke transformation using 
\begin{alignat}{1}
	\bm{v}_{\textrm{abcs}} = \bm{K}^{-1}\bm{v}_{\upalpha\upbeta\upgamma} + \begin{bmatrix} v_{\textrm{cms}} & v_{\textrm{cms}} & v_{\textrm{cms}} \end{bmatrix}\transpose,
\end{alignat}
where the common-mode voltage $v_{\textrm{cms}}$ is chosen arbitrarily.
The constraint on the $\upalpha\upbeta$ voltages are
\begin{alignat}{1}
	\abs{v_{\upalpha} + v_{\textrm{cms}}} \mleq \frac{1}{2} v_{\textrm{dc}}, \\
	\abs{v_{\upalpha} + \sqrt{3}v_{\upbeta} + 2v_{\textrm{cms}}} \mleq v_{\textrm{dc}}, \\
	\abs{v_{\upalpha} - \sqrt{3}v_{\upbeta} + 2v_{\textrm{cms}}} \mleq v_{\textrm{dc}}
\end{alignat}
and the feasible region consists of all points $\bm{v}_{\upalpha\upbeta}$ for which some $v_{\textrm{cms}}$ exists such that these conditions are satisfied.
The extra degree of freedom in form of $v_{\textrm{cms}}$ enlarges the feasible region to
\begin{alignat}{1}
	\abs{v_{\upbeta}} \mleq \frac{1}{\sqrt{3}} v_{\textrm{dc}}, \\
	\abs{v_{\upbeta} + \sqrt{3}v_{\upalpha}} \mleq \frac{2}{\sqrt{3}}v_{\textrm{dc}}, \\
	\abs{v_{\upbeta} - \sqrt{3}v_{\upalpha}} \mleq \frac{2}{\sqrt{3}}v_{\textrm{dc}},
\end{alignat}
which is area bounded by a hexagon as shown in fig. \ref{fig:PMSMConstraintsVab}.
In order to transform this feasible region to the rotating reference frame it is approximated by inscribed disk
\begin{alignat}{1}
	v_{\upalpha}^2 + v_{\upbeta}^2 \mleq V_{\textrm{max}}^2, \\
    V_{\textrm{max}} \meq \frac{v_{\textrm{dc}}}{\sqrt{3}}.
\end{alignat}
The disk remains unchanged when Park transformation is applied and it is written in the DQ variables as
\begin{alignat}{1}
	v_{\textrm{d}}^2 + v_{\textrm{q}}^2 \mleq V_{\textrm{max}}^2.
\end{alignat}
This nonlinear constraint is again approximated by octagon
%\begin{alignat}{1}
%	\abs{v_{\textrm{d}} + (\sqrt{2}-1)v_{\textrm{q}}} \mleq V_{\textrm{max}}, \\
%	\abs{v_{\textrm{d}} - (\sqrt{2}-1)v_{\textrm{q}}} \mleq V_{\textrm{max}}, \\
%	\abs{(\sqrt{2}-1)v_{\textrm{d}} + v_{\textrm{q}}} \mleq V_{\textrm{max}}, \\
%	\abs{(\sqrt{2}-1)v_{\textrm{d}} - v_{\textrm{q}}} \mleq V_{\textrm{max}},
%\end{alignat}
%or using matrix formulation
\begin{alignat}{1}
	\bm{P}_{u}\bm{u} \mleq \bm{p}_{u},
\end{alignat}
where
\begingroup
\renewcommand*{\arraystretch}{0.75}
\begin{alignat}{2}
	\bm{P}_{u} \meq \begin{bmatrix}
		      +1 &   +\sqrt{2}-1 \cr
              +1 &   -\sqrt{2}+1 \cr
              -1 &   +\sqrt{2}-1 \cr
              -1 &   -\sqrt{2}+1 \cr
     +\sqrt{2}-1 &            +1 \cr
     +\sqrt{2}-1 &            -1 \cr
     -\sqrt{2}+1 &            +1 \cr
     -\sqrt{2}+1 &            -1
	\end{bmatrix}, \quad
	\bm{p}_{u} = \begin{bmatrix}
		V_{\textrm{max}} \cr
		V_{\textrm{max}} \cr
		V_{\textrm{max}} \cr
		V_{\textrm{max}} \cr
		V_{\textrm{max}} \cr
		V_{\textrm{max}} \cr
		V_{\textrm{max}} \cr
		V_{\textrm{max}}
	\end{bmatrix}.  \label{eq:PMSM_constraint_u}
\end{alignat}
\endgroup
The octagon is in fig.~\ref{fig:PMSMConstraintsVDQ}.


% Figure
\begin{figure}[tb]
	%\begin{center}
		\begin{subfigure}[b]{0.49\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/constraints/constraints1.pdf}
  			\subcaption{Constraints on $\upalpha\upbeta$ currents. \label{fig:PMSMConstraintsCab}}
		\end{subfigure}
		\hspace{0.02\textwidth}
		\begin{subfigure}[b]{0.49\textwidth}
			%\centering
 	 		\includegraphics[width=1.0\textwidth]{figs/constraints/constraints2.pdf}
 	 		\subcaption{Constraints on $\upalpha\upbeta$ voltages. \label{fig:PMSMConstraintsVab}}
		\end{subfigure}
		\par\bigskip
		\begin{subfigure}[b]{0.49\textwidth}
			%\centering
  			\includegraphics[width=1.0\textwidth]{figs/constraints/constraints3.pdf}
  			\subcaption{Aprroximated constraints on DQ currents. \label{fig:PMSMConstraintsCDQ}}
		\end{subfigure}
		\hspace{0.02\textwidth}
		\begin{subfigure}[b]{0.49\textwidth}
			%\centering
 	 		\includegraphics[width=1.0\textwidth]{figs/constraints/constraints4.pdf}
 	 		\subcaption{Approximated constraints on DQ voltages. \label{fig:PMSMConstraintsVDQ}}
		\end{subfigure}		
	  	\caption{Current and voltage constraints transformed to $\upalpha\upbeta$ variables \subref*{fig:PMSMConstraintsCab} and \subref*{fig:PMSMConstraintsVab}, and approximated constraints in DQ variables \subref*{fig:PMSMConstraintsCDQ} and \subref*{fig:PMSMConstraintsVDQ}.\label{fig:PMSMConstraints}}
	%\end{center}
\end{figure}



